/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction,
  BaseContract,
  ContractTransaction,
  Overrides,
  CallOverrides,
} from "ethers";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";
import type { TypedEventFilter, TypedEvent, TypedListener } from "./common";

interface GPv2SettlementInterface extends ethers.utils.Interface {
  functions: {
    "setPreSignature(bytes,bool)": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "setPreSignature",
    values: [BytesLike, boolean]
  ): string;

  decodeFunctionResult(
    functionFragment: "setPreSignature",
    data: BytesLike
  ): Result;

  events: {
    "Trade(address,address,address,uint256,uint256,uint256,bytes)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "Trade"): EventFragment;
}

export type TradeEvent = TypedEvent<
  [string, string, string, BigNumber, BigNumber, BigNumber, string] & {
    owner: string;
    sellToken: string;
    buyToken: string;
    sellAmount: BigNumber;
    buyAmount: BigNumber;
    feeAmount: BigNumber;
    orderUid: string;
  }
>;

export class GPv2Settlement extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  listeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter?: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): Array<TypedListener<EventArgsArray, EventArgsObject>>;
  off<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  on<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  once<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeListener<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeAllListeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): this;

  listeners(eventName?: string): Array<Listener>;
  off(eventName: string, listener: Listener): this;
  on(eventName: string, listener: Listener): this;
  once(eventName: string, listener: Listener): this;
  removeListener(eventName: string, listener: Listener): this;
  removeAllListeners(eventName?: string): this;

  queryFilter<EventArgsArray extends Array<any>, EventArgsObject>(
    event: TypedEventFilter<EventArgsArray, EventArgsObject>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEvent<EventArgsArray & EventArgsObject>>>;

  interface: GPv2SettlementInterface;

  functions: {
    setPreSignature(
      orderUid: BytesLike,
      signed: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;
  };

  setPreSignature(
    orderUid: BytesLike,
    signed: boolean,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  callStatic: {
    setPreSignature(
      orderUid: BytesLike,
      signed: boolean,
      overrides?: CallOverrides
    ): Promise<void>;
  };

  filters: {
    "Trade(address,address,address,uint256,uint256,uint256,bytes)"(
      owner?: string | null,
      sellToken?: null,
      buyToken?: null,
      sellAmount?: null,
      buyAmount?: null,
      feeAmount?: null,
      orderUid?: null
    ): TypedEventFilter<
      [string, string, string, BigNumber, BigNumber, BigNumber, string],
      {
        owner: string;
        sellToken: string;
        buyToken: string;
        sellAmount: BigNumber;
        buyAmount: BigNumber;
        feeAmount: BigNumber;
        orderUid: string;
      }
    >;

    Trade(
      owner?: string | null,
      sellToken?: null,
      buyToken?: null,
      sellAmount?: null,
      buyAmount?: null,
      feeAmount?: null,
      orderUid?: null
    ): TypedEventFilter<
      [string, string, string, BigNumber, BigNumber, BigNumber, string],
      {
        owner: string;
        sellToken: string;
        buyToken: string;
        sellAmount: BigNumber;
        buyAmount: BigNumber;
        feeAmount: BigNumber;
        orderUid: string;
      }
    >;
  };

  estimateGas: {
    setPreSignature(
      orderUid: BytesLike,
      signed: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    setPreSignature(
      orderUid: BytesLike,
      signed: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;
  };
}
